//setwindowlong(myWind,GWL_STYLE,getwindowlong(myWind,GWL_STYLE) or WS_VSCROLL);
unit bar;

interface

uses
  Classes,myCol,mydialogs,
  //a lot is not needed:
  Dialogs, Messages, SysUtils,
  Windows, ActiveX, ComObj, ComServ,
  Forms,Registry, MSHTML_TLB, SHDocVw_TLB, SHLOBJ,CommCtrl,textdata, barutil
          ,Graphics, Controls,
  StdActns, ActnList, ToolWin,
  ExtCtrls, OleCtrls, StdCtrls, ImgList,  ComCtrls;

type
  TBarFac = class(TComObjectFactory)
	  private
		procedure AddKeys;
		procedure RemoveKeys;
	  public
		procedure UpdateRegistry(Register: Boolean); override;
	  end;
  TBar = class(TComObject, IObjectWithSite, IDeskBand, IPersistStream, IInputObject, IOleWindow, IDockingWindow, IWndHook)
    private
                windProcInst:TfarProc;
    protected
    public
                myWind:hwnd;
                Notes:TList;
                procedure resize; stdcall;
                procedure closeNotes;
                procedure loadNotes(col:pointer);
                function HookProc(wind:HWND;uid:UInt;wPar:WParam;lPar:LParam): LResult; stdcall;
                function WindProc(wind:HWND;uid:UInt;wPar:WParam;lPar:LParam): LResult; stdcall;
                procedure ProcRestore;
                function RegisterAndCreateWindow:Bool;
                function OnPaint:LResult; stdcall;
                function OnCommand(wPar:WParam;lPar:LParam):LResult;
                procedure FocusChange(toWhat:Bool;ref:Pointer);
                function OnSetFocus(ref:Pointer):LResult;
                function OnKillFocus(ref:Pointer):LResult;
                procedure SetMyWind(what:Hwnd);
		function SetSite(const pUnkSite: IUnknown): HResult; stdcall;
		function GetSite(const riid: TIID;
			out site: IUnknown): HResult; stdcall;

//begin IWndHook
    function getIEproc : TFarProc; stdcall;
    procedure setIEproc(wndProc:TFarproc); stdcall;
    function getMyProc : TFarProc; stdcall;
    function getIErebar: HWND; stdcall;
    procedure setIErebar(xrebar:HWND); stdcall;
//end IWndHook

//begin IInputObject
    function UIActivateIO(fActivate: BOOL; var lpMsg: TMsg): HResult; stdcall;
    function HasFocusIO: HResult; stdcall;
    function TranslateAcceleratorIO(var lpMsg: TMsg): HResult; stdcall;
//end IInputObject

//begin IPersistStream
    function GetClassID(out classID: TCLSID): HResult; stdcall;
    function IsDirty: HResult; stdcall;
    function Load(const stm: IStream): HResult; stdcall;
    function Save(const stm: IStream; fClearDirty: BOOL): HResult; stdcall;
    function GetSizeMax(out cbSize: Largeint): HResult; stdcall;
//end IPersistStream

//begin IDeskBand
    function GetBandInfo(dwBandID, dwViewMode: DWORD; var pdbi: TDeskBandInfo):
      HResult; stdcall;
  //begin IDockingWindow, for IDeskband
    function ShowDW(fShow: BOOL): HResult; stdcall;
    function CloseDW(dwReserved: DWORD): HResult; stdcall;
    function ResizeBorderDW(var prcBorder: TRect; punkToolbarSite: IUnknown;
      fReserved: BOOL): HResult; stdcall;
    //begin IOleWindow, for IDockingWindow
      function GetWindow(out wnd: HWnd): HResult; stdcall;
      function ContextSensitiveHelp(fEnterMode: BOOL): HResult; stdcall;
    //end IOleWindow, for IDockingWindow
  //end IDockingWindow, for IDeskband
//end IDeskBand

    procedure Initialize; override;
    destructor Destroy; override;
    end;

implementation

threadvar //threadvar oder var?
  showAllShit:boolean; //for debug
  myParentWind:hwnd;
  myInputSite:IInputObjectSite;
  myBandID: DWORD;
  myViewMode:DWORD;
  myBrowser:IShellBrowser;
  has_focus:boolean;
  myIEbarProc:TFarProc;
  myBarProc:TFarProc;
  Rebar:hwnd;
  HWNDtb:HWND;

const
  True: wordbool=(1=1);
  False:wordbool=(1=2);
  MIN_SIZE_X=100;
  MIN_SIZE_Y=200;

function TBar.getIErebar: HWND; stdcall;
begin
Result:=Rebar;
end;

procedure TBar.setIErebar(xrebar:HWND); stdcall;
begin
Rebar:=xrebar;
end;

function TBar.getIEproc : TFarProc; stdcall;
begin
  Result:=myIEbarProc;
end;

procedure Tbar.setIEproc(wndProc:TFarproc); stdcall;
begin
  myIEbarProc:=wndProc;
end;

procedure TBar.ProcRestore;
begin
  SetWindowlong(Rebar,GWL_WNDPROC,longword(myIEbarProc));
  FreeWndProcInstance(myBarProc);
  myBarProc:=nil;
end;

function TBar.HookProc(wind:HWND;uid:UInt;wPar:WParam;lPar:LParam): LResult; stdcall;
var
x:^aNote;
begin
case uid of
  WM_DESTROY: //unhook yourself
   begin
     Self.ProcRestore;
     result:=CallWindowProc(Self.getIEproc, Self.getIERebar{wind}, uid, wpar, lpar);
     Self.setIEproc(nil);
     exit;
   end;
  WM_SUPPLETCOL: //changed to new page or reaction to WM_SUPPLETBAR_SHOW
   if(wPar=23)then
     begin
     broadcast(rebar,WM_SUPPLETBAR_VIS,mywind); //to be on the safe side
     loadNotes(pointer(lPar));
     end;
  WM_SUPPLETDELNOTE:
   if(wpar=23)then
     try
       notes.Delete(notes.IndexOf(pointer(lPar)));
     except
     end;
  WM_SUPPLETNEWNOTE:
   if(wpar=23)then
    begin
    x:=pointer(lPar);
    if(getStClass(x.styleClass)='NOTE')and(notes<>nil)then
      begin
      notes.add(x^);
      end;
    end;
  WM_SUPPLET_DOTEMA,WM_SUPPLETBAR_SHOW,WM_SUPPLETBAR_HIDE,WM_SUPPLETBAR_DESTROY,WM_SUPPLETBAR_INFOCUS:
   if(wpar=23)then
     begin
     if(showAllShit)then
       MessageDlg('Intercepted: '+inttostr(uid)+','+inttostr(wpar)+','+inttostr(lpar),mtInformation,[mbOk], 0);
     end;
//  WM_COMMAND:
//     MessageDlg('Intercepted: '+inttostr(uid)+','+inttostr(wpar)+','+inttostr(lpar),mtInformation,[mbOk], 0);
 end;
 result := CallWindowProc(Self.getIEproc, Self.getIERebar{wind}, uid, wpar, lpar);
end;

function TBar.getMyProc : TFarProc; stdcall;
Var
  wp:TMethod;
begin
//  myProcRelease;
  wp.code:=@TBar.HookProc;
  wp.data:=self;
  myBarProc:=makeWndProcInstance(wp);
  Result:=myBarProc;
end;

procedure TBar.SetMyWind(What:Hwnd);
begin
myWind:=What;
end;

function TBar.WindProc(wind:HWND;uid:UInt;wPar:WParam;lPar:LParam): LResult; stdcall;
begin
//if(uid<>78)and(uid<>15)then //WM_NOTIFY und _PAINT ignorieren
//  MessageDlg('debug: recieved msg: '+inttostr(uid)+' from wind '+inttostr(wind),mtInformation,[mbOk], 0);
 case uid of
//  WM_VSCROLL:

  WM_SIZE:
   begin
   Resize;
   Result:=DefWindowProc(wind,uid,wPar,lPar);
   end;
  WM_NCCREATE:
   Result:=DefWindowProc(wind,uid,wPar,lPar);
  WM_NCPAINT:
   begin
      if(Assigned(myBrowser))then
        begin
        HWNDtb:=0;
        myBrowser.GetControlWindow(FCW_TOOLBAR,HWNDtb);
        myBrowser._Release;
        myBrowser:=nil;
        if(HWNDtb=0)or(not(installWndHookTBAR(HWNDtb,pointer(self))))then
           begin
           Result := 1;//ERROR
           MessageDlg('internal error 113',mtInformation,[mbOk], 0);
           exit;
           end;
        broadcast(rebar,WM_SUPPLETBAR_SHOW,wind);
        end;
   Result:=DefWindowProc(wind,uid,wPar,lPar);
   end;
  WM_PAINT:
   begin
   onPaint();
   Result:=DefWindowProc(wind,uid,wPar,lPar);
   end;
  WM_COMMAND:
   begin
   Result:=OnCommand(wPar,lPar);
   end;
  WM_SETFOCUS:
   begin
   Result:=OnSetFocus(pointer(self));
   end;
  WM_KILLFOCUS:
   begin
   Result:=OnKillFocus(pointer(self));
   end;
 else
  begin
//   if(uid<>78)then
//    MessageDlg('default goes for '+inttostr(uid),mtInformation,[mbOk], 0);
    Result:=DefWindowProc(wind,uid,wPar,lPar);
  end;
 end;
end;

function TBar.OnPaint:LResult; stdcall;
var
ps:TPaintStruct;
rc:trect;
te:array[0..50] of Char;
begin
BeginPaint(myWind,ps);
//GetClientRect(myWind,rc);
//fillrect(ps.hdc,rc,GetStockObject(WHITE_BRUSH));
{if(notes=nil)or(notes.count=0)then
  begin
  inc(rc.Left,3);
  inc(rc.Top,3);
  dec(rc.Right,6);
  dec(rc.Bottom,6);
  te:='No notes yet';
  SetTextColor(ps.hdc, RGB(0,0,0));
  SetBkMode(ps.hdc, TRANSPARENT);
  DrawText(ps.hdc,
             te,
             -1,
             rc,
             DT_WORDBREAK);//DT_SINGLELINE or DT_VCENTER
  end;}
EndPaint(myWind,ps);
Result:=0;
end;

function TBar.RegisterAndCreateWindow:Bool;
var
 wc:WNDCLASS;
 rc:TRect;
begin
if not(isWindow(myWind))then
  if(isWindow(myParentWind))then
    begin
    if(not(GetClassInfo(SysInit.HINSTANCE,Bar_CLASS_NAME,wc)))then
      begin
      ZeroMemory(@wc,sizeof(WNDCLASS));
      wc.style          := CS_BYTEALIGNWINDOW or CS_BYTEALIGNCLIENT;// CS_PARENTDC or CS_NOCLOSE or CS_HREDRAW or CS_VREDRAW //or CS_GLOBALCLASS;
      wc.lpfnWndProc    := @defwindowproc;
      wc.cbClsExtra     := 0;
      wc.cbWndExtra     := 0;
      wc.hInstance      := hInstance;
      wc.hIcon          := 0;//LoadIcon(integer(Nil), IDI_APPLICATION);//integer(Nil);//
      wc.hCursor        := LoadCursor(integer(Nil), IDC_ARROW);
      wc.hbrBackground  := HBRUSH(CreateSolidBrush(RGB(255, 255, 255)));
                                  //getStockObject()
                                  //hbrBackground := COLOR_BTNFACE + 1;
      wc.lpszMenuName   := nil;
      wc.lpszClassName  := Bar_CLASS_NAME;
      if not(SUCCEEDED(Windows.RegisterClass(wc)))then
        begin
        MessageDlg('Error 205',mtInformation,[mbOk], 0);
        result:=false;
        Exit;
        end;
      end;
      GetClientRect(myParentWind,rc);
      myWind:=CreateWindowEx(WS_EX_CONTROLPARENT,
                     Bar_Class_Name,
                     nil,
                     WS_CHILD or WS_CLIPCHILDREN,// or WS_CLIPSIBLINGS or WS_VSCROLL
                     rc.left,
                     rc.top,
                     rc.right-rc.left,//CW_USEDEFAULT,//
                     rc.bottom-rc.top,//CW_USEDEFAULT,//
                     myParentWind,
                     0,//integer(Nil),
                     hinstance,
                     Self);
    setwindowlong(myWind,GWL_WNDPROC,longword(windProcInst));
    if(isWindow(mywind))then
      begin
      if(showAllShit)then
         MessageDlg('IS WIND #'+inttostr(mywind),mtInformation,[mbOk], 0);
      end
    else
      MessageDlg('IS NO WIND #'+inttostr(mywind),mtInformation,[mbOk], 0);
  end;
Result:=(myWind<>0);
end;

function TBar.OnCommand(wPar:WParam;lPar:LParam):LResult;
begin
Result:=0;
end;

procedure TBar.FocusChange(toWhat:Bool;ref:Pointer);
begin
 has_focus:=toWhat;
 //inform the input object site that the focus has changed
if(Assigned(myInputSite))then
  myInputSite.OnFocusChangeIS(TBar(ref), toWhat);
end;

function TBar.OnSetFocus(ref:Pointer):LResult;
begin
FocusChange(true,ref);
result:= 0;
end;

function TBar.OnKillFocus(ref:Pointer):LResult;
begin
FocusChange(false,ref);
result:= 0;
end;

procedure TBar.closeNotes;
var
  i:integer;
  x:aNote;
begin
if(notes<>nil)then
  begin
  Notes.pack;
  for i:=0 to Notes.count-1 do
    begin
    x:=aNote(Notes.items[i]);
    if(x<>nil)and(x.myNote<>nil)then
      x.myNote.uninit;
    end;
  Notes.Free;
  Notes:=nil;
  end;
end;

procedure TBar.loadNotes(col:pointer);
var
x:^myDoc;
//y:^aNote;
z:aNote;
i:integer;
begin
closeNotes;
notes:=TList.create;
x:=col;
if(x<>nil)and(x.docName<>'')and(x.notes<>nil)then
  begin
  x.lastScrollPos:=-1;
  x.updateBarNotes;
  x.notes.Pack;
  for i:=0 to x.notes.Count-1 do
    begin
    z:=aNote(x.notes.Items[i]);
    if(z<>nil)and(getStClass(z.styleClass)='NOTE')then
      begin
      notes.Add(z);
      z.show;
      end;
    end;
  end;
end;

procedure TBar.resize; stdcall;
var
i:integer;
x:aNote;
begin
//dohere resize all notes
if(notes<>nil)then
 begin
 notes.Pack;
// MessageDlg('count '+inttostr(notes.count),mtInformation,[mbOk], 0);
 for i:=0 to notes.count-1 do
  begin
  x:=aNote(notes.items[i]);
  if(x<>nil)and(x.myNote<>nil)then
    begin
    x.myNote.adjustSize(-1,-1,-1,-1);
    end;
  end;
 end;
end;

function TBar.ShowDW(fShow: BOOL): HResult; stdcall;
begin
    if(fShow)then
      begin
      broadcast(rebar,WM_SUPPLETBAR_SHOW,myWind);
      ShowWindow(myWind,SW_SHOW);
      end
    else
      begin
      broadcast(rebar,WM_SUPPLETBAR_HIDE,5);
      closeNotes;
      ScrollWindowEx(myWind,0,0,nil,nil,
             0,nil,SW_SCROLLCHILDREN or SW_INVALIDATE or SW_ERASE);
      ShowWindow(myWind,SW_HIDE);
      end;
result:= S_OK;
end;

function TBar.CloseDW(dwReserved: DWORD): HResult; stdcall;
begin
if(isWindow(myWind))then
  begin
  broadcast(rebar,WM_SUPPLETBAR_DESTROY,5);
  closeNotes;
  DestroyWindow(mywind);//dohere close and free all notes
//  Windows.unregisterClass(Bar_Class_name,hInstance); //might need to be removed
  end;
myWind:=0;
result:= S_OK;
end;

function TBar.ResizeBorderDW(var prcBorder: TRect; punkToolbarSite: IUnknown;
      fReserved: BOOL): HResult; stdcall;
	begin
		result:=E_NOTIMPL;
	end;

function TBar.GetWindow(out wnd: HWnd): HResult; stdcall;
begin
 if(showAllShit)then
   MessageDlg('Tbar.GetWindow called',mtInformation,[mbOk], 0);
wnd:=myWind;
result:=S_OK;
end;

function TBar.ContextSensitiveHelp(fEnterMode: BOOL): HResult; stdcall;
begin
result:= E_NOTIMPL;
end;

function TBar.GetBandInfo(dwBandID, dwViewMode: DWORD; var pdbi: TDeskBandInfo):
      HResult; stdcall;
var
  x:integer;
begin
if(@pdbi<>nil)then
  begin
  myBandID := dwBandID;
  myViewMode:= dwViewMode;
  if((pdbi.dwMask and DBIM_MINSIZE)=DBIM_MINSIZE)then
    begin
    pdbi.ptMinSize.x:= MIN_SIZE_X;
    pdbi.ptMinSize.y:= MIN_SIZE_Y;
    end;
  if((pdbi.dwMask and DBIM_MAXSIZE)=DBIM_MAXSIZE)then
    begin
    pdbi.ptMaxSize.x := longint(-1);
    pdbi.ptMaxSize.y := longint(-1);
    end;
  if((pdbi.dwMask and DBIM_INTEGRAL)=DBIM_INTEGRAL)then
    begin
    pdbi.ptIntegral.x := 1;
    pdbi.ptIntegral.y := 1;
    end;
  if((pdbi.dwMask and DBIM_ACTUAL)=DBIM_ACTUAL)then
    begin
    pdbi.ptActual.x := 150;
    pdbi.ptActual.y := 600;
    end;
  if((pdbi.dwMask and DBIM_TITLE)=DBIM_TITLE)then
    begin
    for x:=0 to length(Bar_Class_NameW) do
      pdbi.wszTitle[x]:=Bar_Class_NameW[x];
    pdbi.wszTitle[length(Bar_Class_NameW)+1]:=char(0);
    end;
  if((pdbi.dwMask and DBIM_MODEFLAGS)=DBIM_MODEFLAGS)then
    pdbi.dwModeFlags := DBIMF_VARIABLEHEIGHT;
  if((pdbi.dwMask and DBIM_BKCOLOR)=DBIM_BKCOLOR)then
    pdbi.dwMask := pdbi.dwMask and not(DBIM_BKCOLOR);
  result:= S_OK;
end
else
  Result:= E_INVALIDARG;
end;

procedure init;
begin
  showAllShit:=false;
  myParentWind:=0;
  myBandID:=0;
  myViewMode:=0;
  myIEbarProc:=nil;
  myBarProc:=nil;
  Rebar:=0;
  has_focus:=(1=2);
  hwndTB:=0;
//  myInputSite:=nil;
end;

procedure TBar.Initialize;
Var
  wp:TMethod;
begin
inherited;
wp.code:=@TBar.windProc;
wp.data:=self;
windProcInst:=makeWndProcInstance(wp);
myWind:=0;
init;
end;

destructor TBar.Destroy;
begin
//ComRelease(Pointer(myInputSite));
//ComRelease(Pointer(myBrowser));
freeWndProcInstance(windProcInst);
if(showAllShit)then
  MessageDlg('exit_fkt done',mtInformation,[mbOk], 0);
inherited;
end;

//begin IInputobject
    function TBar.UIActivateIO(fActivate: BOOL; var lpMsg: TMsg): HResult; stdcall;
    begin
    if(isWindow(myWind))then
      if(fActivate)then
        begin
        broadcast(rebar,WM_SUPPLETBAR_INFOCUS,5);
        setfocus(myWind);
        end;
    result:= S_OK;
    end;

    function TBar.HasFocusIO: HResult; stdcall;
    begin
    if(has_focus)then
      result:= S_OK
    else
      result:= S_FALSE;
    end;

    function TBar.TranslateAcceleratorIO(var lpMsg: TMsg): HResult; stdcall;
    begin
      result:= S_FALSE;
    end;
//end IInutObject

//begin IPersistStream
    function TBar.GetClassID(out classID: TCLSID): HResult; stdcall;
    begin
      classID:=Class_Bar;
      result:= S_OK;
    end;

    function TBar.IsDirty: HResult; stdcall;
    begin
      result:= S_FALSE;
    end;

    function TBar.Load(const stm: IStream): HResult; stdcall;
    begin
      result:= S_OK;
    end;

    function TBar.Save(const stm: IStream; fClearDirty: BOOL): HResult; stdcall;
    begin
      result:= S_OK;
    end;

    function TBar.GetSizeMax(out cbSize: Largeint): HResult; stdcall;
    begin
      result:= E_NotImpl;
    end;
//end IPersistStream

//get involved into IE
function TBar.SetSite(const pUnkSite: IUnknown): HResult; stdcall;
var
        myOle: IOleWindow;
        isp,isp2:IServiceProvider;

begin
Result:=S_OK;
if(Assigned(punksite))then
  begin
  init;
  pUnkSite.QueryInterface(IServiceProvider,isp);
  isp.QueryService(SID_STopLevelBrowser,IServiceProvider,isp2);
  isp._Release;
  isp2.QueryService(IID_IShellBrowser,IID_IShellBrowser,myBrowser);
  isp2._Release;
  myParentWind:=0;
  if(SUCCEEDED(punksite.QueryInterface(IOleWindow,myOle)))then
    begin
    myOle.GetWindow(myParentWind);
    myOle._Release;
    end
  else
    begin
    Result := E_Fail;
    MessageDlg('error 3b',mtInformation,[mbOk], 0);
    exit;
    end;
  if(myParentWind=0)then
    begin
    Result := E_Fail;
    exit;
    end;
  if(SUCCEEDED(punksite.QueryInterface(IID_IInputObjectSite,myInputSite)))then
    begin
    myInputSite._AddRef;
    end
  else
    begin
    Result := E_Fail;
    MessageDlg('error 4b',mtInformation,[mbOk], 0);
    exit;
    end;
  if not(RegisterAndCreateWindow)then
    Result:=E_FAIL;
  if(showAllShit)then
    MessageDlg('Setsite done - '+inttostr(integer(self)),mtInformation,[mbOk], 0);
  end
else
  begin
  //init; //CAUSES CRASH...
  //punksite was NULL
  myInputSite._Release;
  myInputSite:=nil;
  end;
end; // SetSite

function TBar.GetSite(const riid: TIID; out site: IUnknown): HResult;
begin
if(showAllShit)then
  MessageDlg('Tbar.GetSite called',mtInformation,[mbOk], 0);
RESULT:=E_Fail; //not necessary
site:=nil;
  if(Assigned(myInputSite))then
    try
      Result:=myInputSite.QueryInterface(riid,site);
    except
    RESULT:=E_Fail;
    end;
end; //GetSite

// Factory for registering this DLL
//register myself
procedure TBarFac.AddKeys;
var
	S: string;
	Reg: TRegistry;
        WindowSize: array[0..8]of byte;
begin
	S := GUIDToString(Class_bar);
	Reg := TRegistry.Create;
	try
		Reg.RootKey := HKEY_CLASSES_ROOT;
		Reg.CreateKey( '\CLSID\' + S + '\' + verticalBarCatID);
                Reg.RootKey := HKEY_LOCAL_MACHINE;
                Reg.CreateKey( BarPath +'\'+S);
                WindowSize[0]:=150;
                WindowSize[1]:=0;
                WindowSize[2]:=0;
                WindowSize[3]:=0;
                WindowSize[4]:=0;
                WindowSize[5]:=0;
                WindowSize[6]:=0;
                WindowSize[7]:=0;
                Reg.OpenKey(BarPath +'\'+S,true);
                Reg.WriteBinaryData ('BarSize', WindowSize,8);
                Reg.CloseKey;
 	finally
		Reg.Free;
	end;
end; // AddKeys

//unregister myself
procedure TBarFac.RemoveKeys;
var
	S: string;
	Reg: TRegistry;
begin
	S := GUIDToString(Class_bar);
	Reg := TRegistry.Create;
	try
		Reg.RootKey := HKEY_CLASSES_ROOT;
		Reg.DeleteKey( '\CLSID\' + S + '\' + verticalBarCatID);
                Reg.RootKey := HKEY_LOCAL_MACHINE;
                Reg.DeleteKey( BarPath +'\'+S);
	finally
		Reg.Free;
	end;
end; // RemoveKeys

procedure TBarFac.UpdateRegistry(Register: Boolean);
begin
	inherited;
	if Register then
		AddKeys
	else
		RemoveKeys;
end; // UpdateRegistry


initialization
  TBarFac.Create(ComServer, TBar, Class_bar,
    'Suppletsbar', Bar_Class_name
            , ciMultiInstance //evtl. ciSingleInstance?
            , tmApartment);   //evtl. statt tmBoth tmApartment
end.

